#include <windows.h>
#include <stdio.h>
#include "AgatRTFaxImageCodec.h"
#include "utils.h"

void PrintUsage( char **argv)
{
	char *chPtr;

	if(( chPtr= ::strrchr( argv[0], '\\'))== 0)
		chPtr= argv[0];
	else
		chPtr++;
	::printf( "Converter  from Huffman code to BMP image\n");
	::printf( "Usage: %s <HuffmanFileName> [BmpFileName]\n", chPtr);
	::printf( "<HuffmanFileName> - file with data code by Huffman.\n");
	::printf( "[BmpFileName] - BMP fax image .\n\n");
}

DWORD dwDecodeArguments( int argc, char **argv, THuffmanToBmpParams *lpDecodeParams)
{
	if(( argc!= 2)&&( argc!= 3))
	{
		PrintUsage( argv);
		return ERROR_INVALID_PARAMETER;
	}
	if( dwFileExist( argv[1])== 0)
	{
		::printf( "File \'%s\' not found.\n", argv[1]);
		return ERROR_INVALID_PARAMETER;
	}
	::lstrcpy( lpDecodeParams->pszHuffmanFileName, argv[1]);
	if( argc== 2)
	{
		::lstrcpy( lpDecodeParams->pszBmpFileName, lpDecodeParams->pszHuffmanFileName);
		SetExtensionToFileName( lpDecodeParams->pszBmpFileName, "bmp");
	}
	else
	{
//		if( dwFileExist( argv[2])== 0)
///		{
//			::printf( "File \'%s\' not found.\n", argv[2]);
//			return ERROR_INVALID_PARAMETER;
//		}
		::lstrcpy( lpDecodeParams->pszBmpFileName, argv[2]);
	}
	return 0;
}

void main( int argc, char **argv)
{
	THuffmanToBmpParams DecodeParams= {0};

	if( dwDecodeArguments( argc, argv, &DecodeParams)!= 0)
		return;

	::printf( "Decode \'%s\' -> \'%s-Page-N\'\n", DecodeParams.pszHuffmanFileName, DecodeParams.pszBmpFileName);
	
	DWORD dwError;
	if(( dwError= dwAFICFaxToBmp( &DecodeParams))!= 0)
	{
		::printf( "Error found %d\n", dwError);
		return;
	}
	char pszResString[2][32]= {"Standart", "Fine"};
	::printf( "Decoder have a success. Pages: %d. Resolution: %s\n",
		DecodeParams.dwPageCount, pszResString[DecodeParams.dwResolution]);
}

